-------------------------------------------------------------------------------
-- pragma synthesis_off
library ieee;
use ieee.std_logic_1164.all;
use work.ImPack.all;

-------------------------------------------------------------------------------
entity ImOutTbE is
end ImOutTbE;
-------------------------------------------------------------------------------

architecture ImOutTbA of ImOutTbE is
  component ImOutE
    port (
      Clk50          : in  std_logic;
      Reset          : in  std_logic;
      R, G, B        : out std_logic_vector(7 downto 0);
      HSync, VSync   : out std_logic;
      Clk25          : out std_logic;
		ClkDiv         : out std_logic_vector(CNDiv downto 0));-- Ausgang Taktteiler
  end component;

  signal Clk50S            : std_logic;
  signal ResetS            : std_logic;
  signal RS, GS, BS        : std_logic_vector(7 downto 0);
  signal HSyncS, VSyncS    : std_logic;
  signal Clk25S            : std_logic;
  signal ClkDivS           : std_logic_vector(CNDiv downto 0);

begin  

  ImOutL : ImOutE
    port map (
      Clk50     => Clk50S,
      Reset     => ResetS,
      R         => RS,
      G         => GS,
      B         => BS,
      HSync     => HSyncS,
      VSync     => VSyncS,
      Clk25     => Clk25S,
		ClkDiv    => ClkDivS);
 
  Takt : process  -- Takt 50Mhz
  begin  
    Clk50S <= '0';
    wait for 10 ns;
    Clk50S <= '1';
    wait for 10 ns;
  end process Takt;
 
  ResetS     <= '0', '1'after 200 ns; -- Reset
end ImOutTbA;
-- pragma synthesis_on
-------------------------------------------------------------------------------
