-- Package fuer gesamtes Projekt
-- Ausgabe eines QVGA-Bilds mit einem VGA-Monitor

library ieee;
use ieee.std_logic_1164.all;

package ImPack is

  constant CHBack  : integer := 48;       -- horizontal back porch
  constant CHData  : integer := 320;      -- pixels per line
  constant CH2Data : integer := 640;      -- pixels per line  
  constant CHFront : integer := 16;       -- horizontal front porch
  constant CHSync  : integer := 96;       -- horizontal sync pulse
  constant CVBack  : integer := 33;       -- vertical back porch
  constant CVData  : integer := 240;      -- lines per frame
  constant CV2Data : integer := 480;      -- lines per frame
  constant CVFront : integer := 10;       -- vertical front porch
  constant CVSync  : integer := 2;        -- vertical sync pulse  
  constant CWidth  : integer := 12;       -- data width bit
  constant CDepth  : integer := 17;       -- address width bit -> 2**depth locations
  subtype  It1024 is integer range 0 to 1024;
  subtype  Itmega is integer range 0 to 1048576;
  constant CNDiv : integer :=12;	  -- Taktteiler
  constant Limit : integer := 24000000;   -- Grenze für langen Tastendruck
  constant CounterWidth : integer := 32;  -- Wortbreite für Zähler
end ImPack;




