-- Package fuer ImOutM und ImPro
-- Daten eines Minibilds

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

PACKAGE ImPackM IS

  CONSTANT CHBack  : integer := 2;      -- horizontal back porch
  CONSTANT CHData  : integer := 4;      -- pixels per line
  CONSTANT CH2Data : integer := 8;      -- pixels per line  
  CONSTANT CHFront : integer := 1;      -- horizontal front porch
  CONSTANT CHSync  : integer := 3;      -- horizontal sync pulse
  CONSTANT CVBack  : integer := 3;      -- vertical back porch
  CONSTANT CVData  : integer := 3;      -- lines per frame
  CONSTANT CV2Data : integer := 6;      -- lines per frame
  CONSTANT CVFront : integer := 2;      -- vertical front porch
  CONSTANT CVSync  : integer := 1;      -- vertical sync pulse  
  CONSTANT CWidth  : integer := 12;     -- data width bit
  CONSTANT CDepth  : integer := 4;  -- address width bit -> 2**depth locations
  SUBTYPE  It1024 IS integer RANGE 0 TO 1024;
  SUBTYPE  Itmega IS integer RANGE 0 TO 1048576; 
    CONSTANT CNDiv : integer := 12;     -- Taktteiler
  CONSTANT Limit        : integer := 4;  -- Grenze für langen Tastendruck
  CONSTANT CounterWidth : integer := 8;  -- Wortbreite für Zähler

END ImPackM;




