-- Ausgabe eines Minibilds
-- Bilddaten vom ramm
-- Taktsignale von clockgen

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE work.ImPack.ALL;

ENTITY ImReadE IS
  PORT (
    Clk25 : IN  std_logic;                            -- clock vga
    Reset : IN  std_logic;                            -- Reset, low-active
    PixR  : IN  std_logic_vector(CWidth-1 DOWNTO 0);  -- ram data
    AddrR : OUT std_logic_vector(CDepth-1 DOWNTO 0);  -- ram address
    R     : OUT std_logic_vector(7 DOWNTO 0);         -- pixel R value
    G     : OUT std_logic_vector(7 DOWNTO 0);         -- pixel G value
    B     : OUT std_logic_vector(7 DOWNTO 0);         -- pixel B value
    HSync : OUT std_logic;                            -- horizontal sync
    VSync : OUT std_logic);                           -- vertical sync
END ImReadE;

ARCHITECTURE ImReadA OF ImReadE IS
Signal VisibleS : boolean :=false;
Signal AddrR_S : std_logic_vector(CDepth-1 DOWNTO 0);
Signal Row_S, Col_S : integer; --Überprüfung
Signal AddrRV_S : std_logic_vector(CDepth-1 DOWNTO 0);
BEGIN

ImRead:process (Reset, ClK25) is
Variable Col : integer :=0;
Variable Row : integer :=1;
Variable AddrRV : std_logic_vector(CDepth-1 DOWNTO 0);
begin

	if Reset = '0' then
	AddrR_S <= (others => '0');
	Row := 1;
	Col := 0;
	elsif rising_edge(Clk25) then
	Col := Col+1;
	VisibleS <= false;
		if Col=(ChBack+CH2Data+ChFront+ChSync) then -- bei Verdopplung CH2Data
		Col :=0;
		Row := Row+1;
		end if;
		
		if Row>(CVBack+CV2Data+CVFront+CVSync) and Col=0 then
			Row :=1;
		end if;
		
		if Col>=(ChBack+CH2Data+ChFront) then
		HSync <= '0';
		else HSync <= '1';
		end if;
		
		
		
		if Row > CVBack and Row <= (CVBack+CV2Data) then 	--Zeile sichtbar
			if Row mod 2 = 0 and Col = 0 then
				AddrRV := AddrR_S;
			elsif Row mod 2 = 1 and Col =0 then
				AddrR_S <= AddrRV;
			end if;
			
			if Col > CHBack and Col <= (ChBack+CH2Data) then -- Spalte sichtbar
			VisibleS <= true;
				if Col mod 2 = 0 then
					AddrR_S <= AddrR_S+1;
				end if;
				if Col = (CHBack + CH2Data) and Row = (CVBack+CV2Data-1) then --letzterBP/vorl.Z
				AddrR_S <= AddrRV;
				end if;
				if Col = (CHBack + CH2Data) and Row = (CVBack+CV2Data) then --letzterBP/letzteZ
				AddrR_S <= (others => '0');
				AddrRV := (others => '0');
				end if;		
			end if;
		elsif Row >(CVBack+CV2Data+CVFront) then
			VSync <= '0';
		else VSync <= '1';
		end if;
			
	end if;
	
	Row_S <= Row;
	Col_S <= Col;
	AddrRV_S <= AddrRV;
end process;

AddrR <= AddrR_S;

ausgabe : process (VisibleS, PixR)
begin
	if (VisibleS = true) then 
		R <= PixR (CWidth-1 downto CWidth-4) & "0000";
		G <= PixR (CWidth-5 downto CWidth-8) & "0000";
		B <= PixR (CWidth-9 downto CWidth-12) & "0000";
	else 
		R <= (others => '0');
		G <= (others => '0');
		B <= (others => '0');
	end if;
end process;
END ImReadA;
